define(function() {
  var LocalStorageShim;
  LocalStorageShim = (function() {
    LocalStorageShim.instance = null;

    function LocalStorageShim() {
      if (LocalStorageShim.instance !== null) {
        return LocalStorageShim.instance;
      }
      this.length = 0;
      this._data = {};
      LocalStorageShim.instance = this;
    }

    LocalStorageShim.prototype.getItem = function(key) {
      var value;
      value = this._data[key];
      if (value === void 0) {
        return null;
      }
      return value;
    };

    LocalStorageShim.prototype.setItem = function(key, value) {
      this._data[key] = value;
      this.length += 1;
      return true;
    };

    LocalStorageShim.prototype.removeItem = function(key) {
      if (!this._data[key]) {
        return false;
      }
      this._data[key] = null;
      delete this._data[key];
      this.length -= 1;
      return true;
    };

    LocalStorageShim.prototype.clear = function() {
      var item;
      this.length = 0;
      for (item in this._data) {
        this._data[item] = null;
      }
      this._data = {};
      return true;
    };

    LocalStorageShim.prototype.key = function(index) {
      var i, key, value, _ref;
      i = 0;
      _ref = this._data;
      for (key in _ref) {
        value = _ref[key];
        if (i === index) {
          return key;
        }
        i++;
      }
      return false;
    };

    return LocalStorageShim;

  })();
  return LocalStorageShim;
});
